package labSolutions;

import lecture.IntList;
import lecture.IntListUtil;

public class Reverse {
	
	/*
	(define (naivereverse alist)
	  (if (null? alist)
	    '()
	    (append (naivereverse (cdr alist)) (cons (car alist) '()))))
	 */
	
	public static IntList naiveReverse(IntList aList) {
		if (IntList.isNil(aList)) {
			return IntList.nil;
		} else {
			return IntListUtil.append(naiveReverse(IntList.cdr(aList)), 
					IntList.cons(IntList.car(aList),IntList.nil));
		}
	}
	
	/*
	(define (rev alist acc) 
	  (if (null? alist)
	    acc
	    (rev (cdr alist) (cons (car alist) acc))))
	    
	(define (reverse alist)
	  (rev alist '()))
	 */
	
	public static IntList iterReverseTry(IntList aList,IntList acc) {
		if (IntList.isNil(aList)) {
			return acc;
		} else {
			return iterReverseTry(IntList.cdr(aList), IntList.cons(IntList.car(aList),acc));
		}
	}
	
	public static IntList iterativeReverseTry(IntList aList) {
		return iterReverseTry(aList,IntList.nil);
	}
	
	/*
	 proper iterative behavior can only be achieved with
	 a loop in Java
	 */
	
	public static IntList iterativeReverse(IntList aList) {
		IntList acc = IntList.nil;
		while (!IntList.isNil(aList)) {
			acc = IntList.cons(IntList.car(aList),acc);
			aList = IntList.cdr(aList);
		}
		return acc;
	}
}
