package lecture;

public class Factorial {
	
	/*
	(define (factorial i)
	  (if (<= i 0)
	    1
	    (* i (factorial (- i 1)))))
	 */
	
	public static int factorial(int i) {
		if (i <= 1) {
			return 1;
		} else {
		    return i * factorial(i - 1);
		}
	}
	
	/*
	(define (iterfactorial i acc)
	  (if (<= i 1)
	    acc
	    (iterfactorial (- i 1) (* acc i))))
	    
	 (define (iterativefactorial i)
	   (iterfactorial i 1))
	 */
	
	private static int iterFactorialTry(int i, int acc) {
	   if (i <= 1) {
		   return acc;
	   } else {
		   return iterFactorialTry(i-1,acc*i);
	   }
	}
	
	public static int iterativeFactorialTry(int i) {
		return iterFactorialTry(i,1);
	}
	
	/*
	 real iterative behavior can only be achieved
	 with a loop in Java
	 */
	
	public static int iterativeFactorial(int i) {
		int acc = 1;
		while (i > 1) {
			acc = acc * i;
			i = i - 1;
		}
		return acc;
	}
}
