package lecture;

public class IntListTest {

	public static void main(String[] args) {
		
		int[] someIntegers = {1, 2, 3, 4};
		
		IntList aList = IntList.intList(someIntegers);
		
		int[] someMoreIntegers = {5, 6, 7, 8};
		
		IntList anotherList = IntList.intList(someMoreIntegers);
		
		/* TEST 1: print out list */
		
		System.out.println("TEST 1: printing list");
		IntList.print(aList);
		
		/* TEST 2: length */
		
		System.out.println("TEST 2: length");
		System.out.println(IntListUtil.length(aList));
		
		/* TEST 3: append */
		
		System.out.println("TEST 3: append");
		IntList.print(IntListUtil.append(aList,anotherList));
		
		/* TEST 4: naiveReverse */
		
		System.out.println("TEST 4: naiveReverse");
		IntList.print(IntListUtil.naiveReverse(aList));
		
		/* TEST 5: square */
		
		System.out.println("Test 5: square");
		IntList.print(IntListUtil.square(aList));
		
		/* TEST 6: sum */
		
		System.out.println("Test 6: sum");
		System.out.println(IntListUtil.sum(aList));
		
		/* TEST 7: iterativeLengthTry */
		
		System.out.println("Test 7: iterativeLengthTry");
		System.out.println(IntListUtil.iterativeLengthTry(aList));
		
		/* TEST 8: iterativeLength */
		
		System.out.println("Test 8: iterativeLength");
		System.out.println(IntListUtil.iterativeLength(aList));
		
	}

}
